/*
      Modified Button with LED Tact Switch
    
    When tact button is LOW, blue tact LED is HIGH and red Arduino LED is LOW.
    When tact button is HIGH, blue tact LED is LOW and red Arduino LED is HIGH.
    
     The circuit:
     * LED on Arduino attached from pin 13 to ground
     * Tact switch pushbutton attached to pin 12 
     * Tact switch LED attached to pin 11
     * Internal pull-up resistor enabled on pin 12
    
        ARDUINO LED: Physical pin 17 > Arduino IDE pin 13
        TACT SWITCH LED: Physical pin 15 > Arduino IDE pin 11
        TACT SWITCH BUTTON: Physical pin 16 > Arduini IDE pin 12
    
     created 2005
     by DojoDave <http://www.0j0.org>
     modified 21 June 2015
     by Jill Hartley Yokota
    
     This example code is in the public domain.
    
     http://www.arduino.cc/en/Tutorial/Button
     */
    
    // constants won't change. They're used here to
    // set pin numbers:
    const int buttonPin = 12;     // the number of the pushbutton pin
    const int ledPin =  13;      // the number of the LED pin
    const int tactledPin = 11;    // the number of the tact LED pin
    
    // variables will change:
    int buttonState = 0;         // variable for reading the pushbutton status
    
    void setup() {
      // initialize the LED pin as an output:
      pinMode(ledPin, OUTPUT);
      // initialize the pushbutton pin as an input:
      pinMode(buttonPin, INPUT);
      // initialize the tact LED pin as an output:
      pinMode(tactledPin, OUTPUT);
      
      
       //configure pin12 as an input and enable the internal pull-up resistor
      pinMode(12, INPUT_PULLUP);  
      
    }
    
    void loop() {
      // read the state of the pushbutton value:
      buttonState = digitalRead(buttonPin);
    
      // check if the pushbutton is pressed.
      // if it is, the buttonState is LOW:
      if (buttonState == LOW) {
        // turn LED on:
        digitalWrite(ledPin, HIGH);
        // turn tactLED off:
        digitalWrite(tactledPin, LOW);
      }
      else {
        // turn LED off:
        digitalWrite(ledPin, LOW);
        // turn tact LED on:
        digitalWrite(tactledPin, HIGH);
      }
    }
