// Simple NeoPixel test.  Lights just a few pixels at a time so a
// 1m strip can safely be powered from Arduino 5V pin.  Arduino
// may nonetheless hiccup when LEDs are first connected and not
// accept code.  So upload code first, unplug USB, connect pixels
// to GND FIRST, then +5V and digital pin 6, then re-plug USB.
// A working strip will show a few pixels moving down the line,
// cycling between red, green and blue.  If you get no response,
// might be connected to wrong end of strip (the end wires, if
// any, are no indication -- look instead for the data direction
// arrows printed on the strip).

#include <Adafruit_NeoPixel.h>

#define PIN      5
#define N_LEDS 96

Adafruit_NeoPixel strip = Adafruit_NeoPixel(N_LEDS, PIN, NEO_GRB + NEO_KHZ800);

const int buttonPin = 12;     // the number of the pushbutton pin
const int ledPin =  11;      // the number of the tact LED pin
 
int buttonState = 0;         // variable for reading the pushbutton status

void setup() {

      // initialize the pushbutton pin as an input:
      pinMode(buttonPin, INPUT);
 
      // initialize the tact LED pin as an output:
      pinMode(ledPin, OUTPUT);
  
      //configure pin12 as an input and enable the internal pull-up resistor
      pinMode(12, INPUT_PULLUP);  
 
  strip.begin();
}

 void loop() {
        // read the state of the pushbutton value:
          buttonState = digitalRead(buttonPin);
          
        // check if the pushbutton is pressed.
        // if it is, the buttonState is HIGH:
        if (buttonState == HIGH) {
            // turn LED off:
            digitalWrite(ledPin, LOW);
         }
         
         else {
            // turn LED on:
            digitalWrite(ledPin, HIGH);  
          }

  chase(strip.Color(255, 40, 40)); // Red
  chase(strip.Color(40, 255, 40)); // Green
  chase(strip.Color(40, 40, 255)); // Blue
}

static void chase(uint32_t c) {
  for(uint16_t i=0; i<strip.numPixels()+4; i++) {
      strip.setPixelColor(i  , c); // Draw new pixel
      strip.setPixelColor(i-4, 0); // Erase pixel a few steps back
      strip.show();
      delay(50);
  }
}

