// Simple NeoPixel test.  Lights just a few pixels at a time so a
// 1m strip can safely be powered from Arduino 5V pin.  Arduino
// may nonetheless hiccup when LEDs are first connected and not
// accept code.  So upload code first, unplug USB, connect pixels
// to GND FIRST, then +5V and digital pin 6, then re-plug USB.
// A working strip will show a few pixels moving down the line,
// cycling between red, green and blue.  If you get no response,
// might be connected to wrong end of strip (the end wires, if
// any, are no indication -- look instead for the data direction
// arrows printed on the strip).

#include <Adafruit_NeoPixel.h>

#define PIN      5
#define N_LEDS 96

// constants won't change. They're used here to
// set pin numbers:

const int buttonPin = 12;     // the number of the pushbutton pin
const int ledPin =  11;      // the number of the LED pin

// variables will change:
int buttonState = 0;         // variable for reading the pushbutton status


Adafruit_NeoPixel strip = Adafruit_NeoPixel(N_LEDS, PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  
  strip.begin();
   //THE ILLUM LED TACT SWITCH HAS BOTH LED AND PIN TO CONFIGURE
   // initialize the button's LED pin as an output.  
  
  strip.show(); // Initialize all pixels to 'off'
   
  pinMode(ledPin, OUTPUT);
   //configure button's pin as an input and enable the internal pull-up resistor.
  pinMode(buttonPin, INPUT_PULLUP);
}

    // THIS IS THE CODE BLOCK FOR WHEN THE BUTTON IS NOT PUSHED,
    // EVERYTHING IN HERE HAPPENS WHEN THE BUTTON IS NOT PUSHED
void loop() {
  
 //TURN LED ON IN BUTTON WHEN LOW.
  
  
  
    // read the state of the pushbutton value.  BUTTON IS NORMALLY HIGH OR "ON":
  buttonState = digitalRead(buttonPin);

  // check if the pushbutton is pressed.  WHEN PRESSED, BUTTON IS LOW OR "OFF":
  if (buttonState == HIGH) {
    // turn LEDs OFF:
    digitalWrite(ledPin, LOW); 
       strip.clear();


  }
  
  
  else {
    // THIS IS THE CODE BLOCK FOR WHEN THE BUTTON IS PUSHED,
    // EVERYTHING IN HERE HAPPENS WHEN THE BUTTON IS PUSHED
    // turn LEDs ON WHEN BUTTON IS PUSHED.  WHEN BUTTON PUSHED ITS CONNECTED TO GND:
  
  //TURN LED OFF IN BUTTON WHEN HIGH.
  
  digitalWrite(ledPin, HIGH);
  //erase all pixels
  while(1){
    for(int i=0; i<12; i++) {
    for(int j = 12; j>=0; j--){
      writePixel(i,j,strip.Color(50,i*30,i*50));
      delay(10);
      writePixel(j,i,strip.Color(50,i*30,i*50));
    }
  }
  }

  
  //chase(strip.Color(50,0,50)); // Purple
  /*for(int i=0; i<12; i++) {
  writePixel(i-4,i*2,strip.Color(50,30,i*50));
  }*/
  //writePixel(1,0,(strip.Color(50,0,50)));
  
   /*
  chase(strip.Color(50, 0, 50)); // Red
  chase(strip.Color(0, 255, 0)); // Green
  chase(strip.Color(0, 0, 255)); // Blue
  */
  }
  
  

}

static void chase(uint32_t c) {
  for(uint16_t i=0; i<strip.numPixels()+4; i++) {
      strip.setPixelColor(i  , c); // Draw new pixel
      strip.setPixelColor(i-4, 0); // Erase pixel a few steps back
      strip.show();
     // delay(25);
      delay(30);
  }
}

//address on a per-pixel basis, 8x12 zig-zag matrix
static void writePixel(int row, int column, uint32_t color) {
  int number_of_rows = 12;
  int number_of_columns = 8;
  int pixelNumber; // the pixel we intend to light
  // calculate pixel from row/column
  if(row%2) { // odd rows count down
    pixelNumber = (row+1) * number_of_rows - (column + 1);
  }
  else{ // even rows count up
    pixelNumber = row * number_of_rows + column;
  }
  strip.setPixelColor(pixelNumber,color); // light up the pixel
  strip.show();
}  
